<?php
# @Author: Aaron Bowie
# @Date:   Saturday, September 16th 2017, 12:02:47 am
# @Email:  support@weareag.co.uk
# @Filename: ag-woocommerce-sagepay.php
# @Last modified by:   Aaron Bowie
# @Last modified time: Thursday, May 24th 2018, 5:25:18 pm
defined('ABSPATH') or die("No script kiddies please!");
/*
Plugin Name: AG SagePay Server - WooCommerce Gateway
Plugin URI: https://www.weareag.co.uk
Description: Extends WooCommerce by Adding the SagePay Server Gateway.
Version: 1.0.4
Author: Aaron Bowie
Author URI: https://www.weareag.co.uk
WC requires at least: 3.0.0
WC tested up to: 3.4.0
*/


// Plugin repo bits
$version = '1.0.4';
$plugin_id = 'AV3hPB6yLcFvu0YC';
$repo_url = 'https://weareag.co.uk/update/';
// defined
if ( ! defined( 'AG_SagePay_server_Repo' ) ) {
	define( 'AG_SagePay_server_Repo', $repo_url );
}
if ( ! defined( 'AG_SagePay_server_id' ) ) {
	define( 'AG_SagePay_server_id', $plugin_id );
}
if ( ! defined( 'AG_SagePay_server_ver' ) ) {
	define( 'AG_SagePay_server_ver', $version );
}

if ( ! defined( 'AGD_KEY' ) ) {
	define( 'AGD_KEY', '56cdf3f59bdb87.92903929' );
}
if ( ! defined( 'AGD' ) ) {
	define( 'AGD', 'https://www.weareag.co.uk' );
}
if ( ! defined( 'ITEM' ) ) {
	define( 'ITEM', '2993' );
}


// Include Gateway Class and register Payment Gateway with WooCommerce
add_action( 'plugins_loaded', 'ag_sagepay_server_init', 0 );
function ag_sagepay_server_init() {

  // Check for Woo
	if ( ! class_exists( 'WC_Payment_Gateway' ) ) return;

	include_once( 'ag-woocommerce-sagepay-class.php' );

	// Lets add it too WooCommerce
	add_filter( 'woocommerce_payment_gateways', 'ag_add_sagepay_server_gateway' );
	function ag_add_sagepay_server_gateway( $methods ) {
		$methods[] = 'ag_sagepay_server';
		return $methods;
	}
}

// Add custom action links
add_filter( 'plugin_action_links_' . plugin_basename( __FILE__ ), 'ag_sagepay_server_action_links' );
function ag_sagepay_server_action_links( $links ) {
	$plugin_links = array(
		'<a href="' . admin_url( 'admin.php?page=wc-settings&tab=checkout' ) . '">' . __( 'Settings', 'ag-sagepay-direct' ) . '</a>',
	);

	// Merge our new link with the default ones
	return array_merge( $plugin_links, $links );
}


function load_updates() {
	if ( ! class_exists( 'RKV_Remote_Updater' ) ) {
		include( 'lib/RKV_Remote_Updater.php' );
	}
}

add_action( 'admin_init', 'agd_SagePay_server_remote_update' );
function agd_SagePay_server_remote_update() {

	// ensure the class exists before running
	if ( ! class_exists( 'RKV_Remote_Updater' ) ) {
		return;
	}

	$updater = new RKV_Remote_Updater( AG_SagePay_server_Repo, __FILE__, array(
		'unique'    => AG_SagePay_server_id,
		'version'   => AG_SagePay_server_ver,
	)
	);
}


/*-----------------------------------------------------------------------------------*/
/*	Licence management section
/*-----------------------------------------------------------------------------------*/

if ( ! function_exists( 'ag_plugin_licence' ) ) {

	add_action('admin_menu', 'ag_plugin_licence');
	function ag_plugin_licence() {
	  add_menu_page('AG License Activation Menu', 'AG Plugins', 'manage_options', 'AG_licence', 'AG_plugins_page', 'dashicons-admin-network');
		//plugins_url( 'AG-Woo-SagePay-Server/img/weareag.svg' )
	}

}


if ( ! function_exists( 'AG_plugins_page' ) ) {

	function AG_plugins_page() {
	    echo '<div class="wrap">';
	    echo '<h2>We are AG Plugin License Management</h2>';
			echo '<p>Please enter the license key for this product to activate it. You were given a license key when you purchased this item.</p>';

			do_action( 'load_ag_plugins' );

			echo '<p>When moving plugin from one site to another (from development server to live site) you <strong>MUST</strong> deactivate your plugin first on development before you move it over.</p>';
	    echo '</div>';
	}

}

/*-----------------------------------------------------------------------------------*/
/*	End
/*-----------------------------------------------------------------------------------*/


add_action( 'load_ag_plugins', 'sagepay_licence_settings' );
function sagepay_licence_settings() {

	if (isset($_REQUEST['AGD_SagePay_server_Key_activate_license'])) {
			$license_key = $_REQUEST['AGD_SagePay_server_Key'];
			// API query parameters
			$api_params = array(
					'slm_action' => 'slm_activate',
					'secret_key' => AGD_KEY,
					'license_key' => $license_key,
					'registered_domain' => $_SERVER['SERVER_NAME'],
					'item_reference' => urlencode(pro),
			);
			// Send query to the license manager server
			$query = esc_url_raw(add_query_arg($api_params, AGD));
			$response = wp_remote_get($query, array('timeout' => 20, 'sslverify' => false));
			$license_data = json_decode(wp_remote_retrieve_body($response));

			if($license_data->result == 'success'){ //Success was returned for the license activation
					update_option('AGD_SagePay_server_Key', $license_key);
					update_option('AGD_SagePay_server_Key_message', $license_data->message);
					add_option('AGD_SagePay_server_Key_message', $license_data->message);
					$fulldate = $response['headers']['expires'];
					$words = explode(" ", $fulldate);
					$date = join(" ", array_slice($words, 0, 4));
					add_option('AGD_SagePay_server_Key_expires', $date);
					update_option('AGD_SagePay_server_Key_expires', $date);
			} else {
				update_option('AGD_SagePay_server_Key_message', $license_data->message);
			}
	}
	/*** End of license activation ***/
	/*** License activate button was clicked ***/
	if (isset($_REQUEST['AGD_SagePay_server_Key_deactivate_license'])) {
			$license_key = $_REQUEST['AGD_SagePay_server_Key'];
			// API query parameters
			$api_params = array(
					'slm_action' => 'slm_deactivate',
					'secret_key' => AGD_KEY,
					'license_key' => $license_key,
					'registered_domain' => $_SERVER['SERVER_NAME'],
					'item_reference' => urlencode(pro),
			);
			$query = esc_url_raw(add_query_arg($api_params, AGD));
			$response = wp_remote_get($query, array('timeout' => 20, 'sslverify' => false));

			// License data.
			$license_data = json_decode(wp_remote_retrieve_body($response));
			// TODO - Do something with it.
			if($license_data->result == 'success'){//Success was returned for the license activation
					//Remove the licensse key from the options table. It will need to be activated again.
					update_option('AGD_SagePay_server_Key', '');
					update_option('AGD_SagePay_server_Key_message', $license_data->message);
					echo $response->headers->expires;
			} else {
				update_option('AGD_SagePay_server_Key_message', $license_data->message);
			}
	}
?>

<form action="" method="post" style="padding-top: 20px; padding-bottom: 20px;">
	<table class="form-table">
			<tr>
				<label class="licence_label" for="AGD_SagePay_server_Key"><strong>Sage Pay Server Licence Key</strong></label>
<th style="width:10px; padding-bottom: 0;"><input class="regular-text" type="password" id="AGD_SagePay_server_Key" name="AGD_SagePay_server_Key"  value="<?php echo get_option('AGD_SagePay_server_Key'); ?>" ><input type="submit" name="AGD_SagePay_server_Key_activate_license" value="Activate" class="button-primary activate_license" /><input type="submit" name="AGD_SagePay_server_Key_deactivate_license" value="Deactivate" class="button" />
<?php if (get_option('AGD_SagePay_server_Key_message') == 'License key activated') { echo '<p style="color: green"><strong>'. get_option('AGD_SagePay_server_Key_message'). '</strong></p>'; } elseif (get_option('AGD_SagePay_server_Key_message') == 'Your License key has expired') {
echo '<p style="color: red"><strong>'. get_option('AGD_SagePay_server_Key_message'). ' to continue getting support and updates make sure you <a href="">update your licence here</a> now.</strong></p>';
} else { echo '<p style="color: red"><strong>'. get_option('AGD_SagePay_server_Key_message'). '</strong></p>'; } ?></th>
			</tr>
	</table>
	<p style="margin-top: 0; ">The plugin settings can be found <a href="<?php echo site_url(); ?>/admin.php?page=wc-settings&tab=checkout&section=ag_sagepay_server">here</a>.</p>

</form>
<hr />
<?php

}




/*-----------------------------------------------------------------------------------*/
/*	GDPR new bits
/*-----------------------------------------------------------------------------------*/

// Adding what we store in custom fields to Woo hook before removing of data.
function remove_sagepay_personal_data($order) {

	$sagepay_meta_to_remove = apply_filters( 'woocommerce_privacy_remove_order_personal_data_meta', array(
			'Status'  		=> 'text',
			'StatusDetail'      			=> 'text',
			'VPSTxId' 							=> 'text',
			'CAVV'     		=> 'text',
			'SecurityKey'     			=> 'text',
			'TxAuthNo'   => 'text',
			'AVSCV2'     			=> 'text',
			'AddressResult'     => 'text',
			'PostCodeResult'     		=> 'text',
			'CV2Result'   => 'text',
			'3DSecureStatus'     		=> 'text',
			'VendorTxCode' => 'text'
		) );

		if ( ! empty( $sagepay_meta_to_remove ) && is_array( $sagepay_meta_to_remove ) ) {
					foreach ( $sagepay_meta_to_remove as $meta_keys => $data_types ) {
						$value = $order->get_meta( $meta_keys );
						if ( empty( $value ) || empty( $data_types ) ) {
							continue;
						}
						$anon_value = function_exists( 'wp_privacy_anonymize_data' ) ? wp_privacy_anonymize_data( $data_types, $value ) : '';

						$anon_value = apply_filters( 'woocommerce_privacy_remove_order_personal_data_meta_value', $anon_value, $meta_keys, $value, $data_types, $order );

						if ( $anon_value ) {
							$order->update_meta_data( $meta_keys, $anon_value );
						} else {
							$order->delete_meta_data( $meta_keys );
						}
					}
				}

}
add_action( 'woocommerce_privacy_before_remove_order_personal_data', 'remove_sagepay_personal_data' );


function sagepay_content() {
	return
	'<p>' . __( 'In the WooCommerce payments section you should list SagePay as a payment processor.<br />
<br />
We accept payments through SagePay. When processing payments, some of your data will be passed to SagePay, including information required to process or support the payment, such as the purchase total and billing information.<br /><br /> 
Once an order has been placed some of the data sent back from SagePay is stored to support the payment and order, this data will remain part of the order until it is deleted.
<br/><br />
Please see SagePays Privacy Policy for more details.' ) . '</p>';
}


function sagepay_privacy_content() {
	$content = sagepay_content();
	wp_add_privacy_policy_content( __( 'AG SagePay Server Gateway' ), $content );
}

add_action( 'admin_init', 'sagepay_privacy_content', 20 );
